Fixed refresh discarding the From line out of the patch header
[guilt.git] / guilt
blob158b385d3b433807999f75006c125e56e50b3d11
1 #!/bin/bash
3 # Copyright (c) Josef "Jeff" Sipek, 2006, 2007
6 export GUILT_VERSION="0.15"
8 if [ `basename $0` = "guilt" ]; then
9 # being run as standalone
11 # by default, we shouldn't fail
12 fail=0
14 if [ $# -ne 0 ]; then
15 # take first arg, and try to execute it
17 cmd="$1"
18 dir=`dirname $0`
20 if [ ! -x "$dir/guilt-$cmd" ]; then
21 echo "Command $cmd not found" >&2
22 echo "" >&2
23 fail=1
24 else
25 shift
26 exec "$dir/guilt-$cmd" "$@"
28 # this is not reached because of the exec
29 echo "Exec failed! Something is terribly wrong!" >&2
30 exit 1
34 # no args passed or invalid command entered, just output help summary
36 echo "Guilt v$GUILT_VERSION"
37 echo ""
38 echo "Pick a command:"
39 for x in `dirname $0`/guilt-*; do
40 [ -x $x ] && echo -e "\t`basename $x`"
41 done
43 echo ""
44 echo "Example:"
45 echo -e "\tguilt-push"
46 echo "or"
47 echo -e "\tguilt push"
49 # now, let's exit
50 exit $fail
53 ########
56 # Library goodies
59 function find_git_dir
61 local d=`git-rev-parse --git-dir`
63 if [ $? -ne 0 -o -z "$d" ]; then
64 echo "Not a git repository" >&2
65 return 1
68 echo "$d"
71 function get_branch
73 git-symbolic-ref HEAD | sed -e 's,^refs/heads/,,'
76 function verify_branch
78 local b=$branch
80 [ ! -d "$GIT_DIR/patches" ] &&
81 echo "Patches directory doesn't exist, try guilt-init" >&2 &&
82 return 1
83 [ ! -d "$GIT_DIR/patches/$b" ] &&
84 echo "Branch $b is not initialized, try guilt-init" >&2 &&
85 return 1
86 [ ! -f "$GIT_DIR/patches/$b/series" ] &&
87 echo "Branch $b does not have a series file" >&2 &&
88 return 1
89 [ ! -f "$GIT_DIR/patches/$b/status" ] &&
90 echo "Branch $b does not have a status file" >&2 &&
91 return 1
92 [ -f "$GIT_DIR/patches/$b/applied" ] &&
93 echo "Warning: Branch $b has 'applied' file - guilt is not compatible with stgit" >&2 &&
94 return 1
96 return 0
99 function get_top
101 tail -1 $GUILT_DIR/$branch/status
104 function get_prev
106 local n=`wc -l < $GUILT_DIR/$branch/status`
107 local n=`expr $n - 1`
109 local idx=0
110 for p in `cat $GUILT_DIR/$branch/status`; do
111 idx=`expr $idx + 1`
112 [ $idx -lt $n ] && continue
113 [ $idx -gt $n ] && break
115 echo $p
116 done
119 function get_series
121 # ignore all lines matching:
122 # - empty lines
123 # - whitespace only
124 # - optional whitespace followed by '#' followed by more
125 # optional whitespace
126 grep -ve '^[[:space:]]*\(#.*\)*$' < $series
129 # usage: index_update_magic
130 function index_update_magic
132 while read l; do
133 fil=`echo $l | cut -d: -f 2`
134 git-update-index --add --remove "$fil"
135 done
138 # usage: do_get_header patchfile
139 function do_get_header
141 # The complexity arises from the fact that we want to ignore the
142 # From line and the empty line after it if it exists
144 # 2nd line skips the From line
145 # 3rd line skips the empty line right after a From line
146 do_get_full_header $1 | awk '
147 BEGIN{skip=0}
148 /^From:/{skip=1; next}
149 /^[ \t\f\n\r\v]*$/ && (skip==1){skip=0; next}
150 {print $0}
151 END{}
155 # usage: do_get_full_header patchfile
156 function do_get_full_header
158 # 2nd line checks for the begining of a patch
159 # 3rd line outputs the line if it didn't get pruned by the above rules
160 cat $1 | awk '
161 BEGIN{ok=1}
162 /^(diff|---)/{ok=0}
163 (ok==1){print $0}
164 END{}
168 # usage: pop_patch
169 function pop_patch
171 git reset --hard HEAD^
173 head -n -1 < $applied > $applied.tmp
174 mv $applied{.tmp,}
177 # usage: push_patch patchname
178 function push_patch
180 local p="$GUILT_DIR/$branch/$1"
181 local pname="$1"
183 local bail=0
185 # apply the patch if and only if there is something to apply
186 if [ `wc -l < $p` -gt 0 ]; then
187 git-apply --reject $p > /dev/null 2> /tmp/guilt.log.$$
188 bail=$?
190 [ $bail -ne 0 ] && cat /tmp/guilt.log.$$ >&2
192 ( git-apply --numstat $p | awk '{print "changed:" $3}';
193 #git-apply --summary $p | awk '
194 # /^ (create|delete)/{print $1 ":" $4}
195 # /^ mode change/{print "mode:" $6}'
196 )| index_update_magic
199 # grab a commit message out of the patch
200 do_get_header $p > /tmp/guilt.msg.$$
202 # make a default commit message if patch doesn't contain one
203 [ ! -s /tmp/guilt.msg.$$ ] && echo "patch $pname" > /tmp/guilt.msg.$$
205 # extract a From line from the patch header, and set
206 # GIT_AUTHOR_{NAME,EMAIL}
207 local author_str=`cat $p | grep -e '^From: ' | sed -e 's/^From: //'`
208 if [ ! -z "$author_str" ]; then
209 local backup_author_name="$GIT_AUTHOR_NAME"
210 local backup_author_email="$GIT_AUTHOR_EMAIL"
211 export GIT_AUTHOR_NAME=`echo $author_str | sed -e 's/ *<.*$//'`
212 export GIT_AUTHOR_EMAIL=`echo $author_str | sed -e 's/[^<]*//'`
215 # commit
216 local treeish=`git-write-tree`
217 local commitish=`git-commit-tree $treeish -p HEAD < /tmp/guilt.msg.$$`
218 echo $commitish > $GIT_DIR/`git-symbolic-ref HEAD`
220 # restore original GIT_AUTHOR_{NAME,EMAIL}
221 if [ ! -z "$author_str" ]; then
222 if [ ! -z "$backup_author_name" ]; then
223 export GIT_AUTHOR_NAME="$backup_author_name"
224 else
225 unset GIT_AUTHOR_NAME
228 if [ ! -z "$backup_author_name" ]; then
229 export GIT_AUTHOR_EMAIL="$backup_author_email"
230 else
231 unset GIT_AUTHOR_EMAIL
235 rm -f /tmp/guilt.msg.$$ /tmp/guilt.log.$$
237 return $bail
240 # usage: must_commit_first
241 function must_commit_first
243 [ `git-diff-files | wc -l` -eq 0 ]
244 return $?
247 # usage: refresh_patch patchname
248 function refresh_patch
250 local p="$GUILT_DIR/$branch/$1"
252 git-diff-files --name-only | (while read n; do git-update-index $n ; done)
254 # get the patch header
255 do_get_full_header $p > /tmp/guilt.diff.$$
257 # get the new patch
258 git-diff HEAD^ >> /tmp/guilt.diff.$$
260 # drop the current commit
261 git-reset --hard HEAD^
263 # move the new patch in
264 mv $p $p.prev
265 mv /tmp/guilt.diff.$$ $p
267 push_patch $1
271 # The following gets run every time this file is source'd
274 export GIT_DIR=`find_git_dir`
275 [ $? -ne 0 ] && exit 1
277 GUILT_DIR="$GIT_DIR/patches"
279 branch=`get_branch`
281 # most of the time we want to verify that the repo's branch has been
282 # initialized, but every once in a blue moon (e.g., we want to run guilt-init),
283 # we must avoid the checks
284 if [ -z "$DO_NOT_CHECK_BRANCH_EXISTENCE" ]; then
285 verify_branch || exit 1
288 # very useful files
289 series="$GUILT_DIR/$branch/series"
290 applied="$GUILT_DIR/$branch/status"